<?php
/**
 * Offers helper functions for language issues.
 */
class d2u_machinery_machine_steel_processing_extension_lang_helper extends d2u_machinery_lang_helper
{
    /**
     * @var array<string, string> Array with englisch replacements. Key is the wildcard,
     * value the replacement.
     */
    public $replacements_english = [
        'd2u_machinery_steel_automation_automationgrades' => 'Degree of Automation',
        'd2u_machinery_steel_automation_feedrate' => 'Feedrate',
        'd2u_machinery_steel_automation_feedrate_sawblade' => 'Sawblade feedrate',
        'd2u_machinery_steel_automation_rush_leader_flyback' => 'Rapid advance/return movement',
        'd2u_machinery_steel_automation_supply_ids' => 'Complementaries',
        'd2u_machinery_steel_automation_supply_multi_stroke' => 'Multiple stroke length',
        'd2u_machinery_steel_automation_supply_single_stroke' => 'Single stroke length',
        'd2u_machinery_steel_beam_color_guns' => 'Number of spray guns',
        'd2u_machinery_steel_beam_continuous_opening' => 'Passage range',
        'd2u_machinery_steel_beam_turbine_power' => 'Drive performance per turbine',
        'd2u_machinery_steel_beam_turbines' => 'Number of turbines',
        'd2u_machinery_steel_bevel_angle' => 'Bevel angle max.',
        'd2u_machinery_steel_carrier_height' => 'Beam height min. / max.',
        'd2u_machinery_steel_carrier_weight' => 'Beam weight max.',
        'd2u_machinery_steel_carrier_width' => 'Beam width min. / max.',
        'd2u_machinery_steel_component_length' => 'Component length max.',
        'd2u_machinery_steel_component_weight' => 'Component Weight max.',
        'd2u_machinery_steel_drilling_axis_drive_power' => 'Drive power axe',
        'd2u_machinery_steel_drilling_diameter' => 'Drill Size',
        'd2u_machinery_steel_drilling_rpm_speed' => 'Spindle speed max.',
        'd2u_machinery_steel_drilling_tools_axis' => 'Number of tools per axis',
        'd2u_machinery_steel_drilling_unit_below' => 'Drilling units from below (U-axis, optional)',
        'd2u_machinery_steel_drilling_unit_horizontal' => 'Drilling unit horizontal (Z- and W-axis)',
        'd2u_machinery_steel_drilling_unit_vertical' => 'Drilling unit vertical (Y-axis)',
        'd2u_machinery_steel_flange_thickness' => 'Flange thickness min. / max',
        'd2u_machinery_steel_materials' => 'Material class',
        'd2u_machinery_steel_procedures' => 'Supply and discharge side',
        'd2u_machinery_steel_processes' => 'Working processes',
        'd2u_machinery_steel_profiles' => 'Profile range',
        'd2u_machinery_steel_punching_diameter' => 'Vertical punch diameter',
        'd2u_machinery_steel_punching_power' => 'Punching Power',
        'd2u_machinery_steel_punching_tools' => 'Number of tools punch unit',
        'd2u_machinery_steel_saw_band' => 'Sawband',
        'd2u_machinery_steel_saw_band_tilt' => 'Sawband inclination',
        'd2u_machinery_steel_saw_blade' => 'Sawblade',
        'd2u_machinery_steel_saw_cutting_speed' => 'Cutting speed (optionally)',
        'd2u_machinery_steel_saw_miter' => 'Mitre range',
        'd2u_machinery_steel_shaving_unit_angle_steel_single_cut' => 'Angle shear single cut',
        'd2u_machinery_steel_sheet_length' => 'Sheet starting material sheet length',
        'd2u_machinery_steel_sheet_thickness' => 'Sheet starting material sheet thickness',
        'd2u_machinery_steel_sheet_width' => 'Sheet starting material sheet width',
        'd2u_machinery_steel_tool_changer_locations' => 'Toolchanger x Magazine places',
        'd2u_machinery_steel_tools' => 'Tools',
        'd2u_machinery_steel_web_thickness' => 'Web thickness min. / max.',
        'd2u_machinery_steel_welding_thickness' => 'Welding throat thickness max.',
        'd2u_machinery_steel_welding_wire_thickness' => 'wire thickness',
        'd2u_machinery_steel_weldings' => 'Welding technique - One-pass – three-pass welding',
        'd2u_machinery_steel_workspace_flat' => 'Working range Flatmaterial',
        'd2u_machinery_steel_workspace_plate' => 'working range Plate',
        'd2u_machinery_steel_workspace' => 'Workspace max.',
        'd2u_machinery_steel_workspace_angle_steel' => 'Working range Anglematerial',
        'd2u_machinery_steel_workspace_min' => 'Working range min.',
        'd2u_machinery_steel_workspace_profile' => 'working range Profile',
        'd2u_machinery_steel_workspace_round' => 'Working range Roundmaterial',
        'd2u_machinery_steel_workspace_square' => 'Working range Square',
    ];

    /**
     * @var array<string, string> Array with german replacements. Key is the wildcard,
     * value the replacement.
     */
    protected array $replacements_german = [
        'd2u_machinery_steel_automation_automationgrades' => 'Automatisierungsgrad',
        'd2u_machinery_steel_automation_feedrate' => 'Vorschub',
        'd2u_machinery_steel_automation_feedrate_sawblade' => 'Sägeblatt-Vorschub',
        'd2u_machinery_steel_automation_rush_leader_flyback' => 'Eilvor-/-Rücklauf',
        'd2u_machinery_steel_automation_supply_ids' => 'Ergänzend',
        'd2u_machinery_steel_automation_supply_multi_stroke' => 'Materialnachschub Mehrfachhub',
        'd2u_machinery_steel_automation_supply_single_stroke' => 'Materialnachschub Einfachhub',
        'd2u_machinery_steel_beam_color_guns' => 'Anzahl Farbpistolen',
        'd2u_machinery_steel_beam_continuous_opening' => 'Durchlauföffnung',
        'd2u_machinery_steel_beam_turbine_power' => 'Leistung pro Turbine',
        'd2u_machinery_steel_beam_turbines' => 'Anzahl Turbinen',
        'd2u_machinery_steel_bevel_angle' => 'Fasenwinkel max.',
        'd2u_machinery_steel_carrier_height' => 'Trägerhöhe min. / max.',
        'd2u_machinery_steel_carrier_weight' => 'Trägergewicht max.',
        'd2u_machinery_steel_carrier_width' => 'Trägerbreite min. / max.',
        'd2u_machinery_steel_component_length' => 'Bauteilelänge min. / max.',
        'd2u_machinery_steel_component_weight' => 'Bauteilgewicht max.',
        'd2u_machinery_steel_drilling_axis_drive_power' => 'Antriebsleistung pro Achse',
        'd2u_machinery_steel_drilling_diameter' => 'Bohrdurchmesser',
        'd2u_machinery_steel_drilling_rpm_speed' => 'Spindeldrehzahl max.',
        'd2u_machinery_steel_drilling_tools_axis' => 'Anzahl Werkzeuge pro Achse',
        'd2u_machinery_steel_drilling_unit_below' => 'Bohreinheiten von unten (U-Achse, optional)',
        'd2u_machinery_steel_drilling_unit_horizontal' => 'Bohreinheiten Horizontal (Z- und W-Achse)',
        'd2u_machinery_steel_drilling_unit_vertical' => 'Bohreinheiten Vertical (Y-Achse)',
        'd2u_machinery_steel_flange_thickness' => 'Flanschdicke min. / max',
        'd2u_machinery_steel_materials' => 'Materialklasse',
        'd2u_machinery_steel_procedures' => 'Verfahren',
        'd2u_machinery_steel_processes' => 'Prozess',
        'd2u_machinery_steel_profiles' => 'Profilbereich',
        'd2u_machinery_steel_punching_diameter' => 'Stanzdurchmesser',
        'd2u_machinery_steel_punching_power' => 'Stanzkraft',
        'd2u_machinery_steel_punching_tools' => 'Anzahl Stanzwerkzeuge',
        'd2u_machinery_steel_saw_band' => 'Sägeband',
        'd2u_machinery_steel_saw_band_tilt' => 'Sägebandneigung',
        'd2u_machinery_steel_saw_blade' => 'Sägeblatt',
        'd2u_machinery_steel_saw_cutting_speed' => 'Schnittgeschwindigkeit (wahlweise)',
        'd2u_machinery_steel_saw_miter' => 'Schwenkbereich für Gehrungsschnitte',
        'd2u_machinery_steel_shaving_unit_angle_steel_single_cut' => 'Winkelstahl-Schereinheit single cut',
        'd2u_machinery_steel_sheet_length' => 'Blech-Ausgangsmaterial Blechlänge',
        'd2u_machinery_steel_sheet_thickness' => 'Blech-Ausgangsmaterial Blechdicke',
        'd2u_machinery_steel_sheet_width' => 'Blech-Ausgangsmaterial Blechbreite',
        'd2u_machinery_steel_tool_changer_locations' => 'Werkzeugwechsler x Magazinplätze',
        'd2u_machinery_steel_tools' => 'Werkzeuge',
        'd2u_machinery_steel_web_thickness' => 'Stegdicke min. / max.',
        'd2u_machinery_steel_welding_thickness' => 'Schweißnahtdicke max.',
        'd2u_machinery_steel_welding_wire_thickness' => 'Drahtdicke',
        'd2u_machinery_steel_weldings' => 'Schweißverfahren - Ein- bis Dreilagenschweißen',
        'd2u_machinery_steel_workspace_flat' => 'Arbeitsbereich Flachmaterial',
        'd2u_machinery_steel_workspace_plate' => 'Arbeitsbereich Platten',
        'd2u_machinery_steel_workspace' => 'Arbeitsbereich max.',
        'd2u_machinery_steel_workspace_angle_steel' => 'Arbeitsbereich Winkelstahl',
        'd2u_machinery_steel_workspace_min' => 'Arbeitsbereich min.',
        'd2u_machinery_steel_workspace_profile' => 'Arbeitsbereich Profile',
        'd2u_machinery_steel_workspace_round' => 'Arbeitsbereich Rundmaterial',
        'd2u_machinery_steel_workspace_square' => 'Arbeitsbereich Vierkantmaterial',
    ];

    /**
     * @var array<string, string> Array with french replacements. Key is the wildcard,
     * value the replacement.
     */
    protected array $replacements_french = [
        'd2u_machinery_steel_automation_automationgrades' => 'Degré d\'automatisation',
        'd2u_machinery_steel_automation_feedrate' => 'Avance',
        'd2u_machinery_steel_automation_feedrate_sawblade' => "d'avance de la lame de scie",
        'd2u_machinery_steel_automation_rush_leader_flyback' => 'Avance / retour rapide',
        'd2u_machinery_steel_automation_supply_ids' => 'Amenage / Evacuation',
        'd2u_machinery_steel_automation_supply_multi_stroke' => 'Amenage matière course multiple',
        'd2u_machinery_steel_automation_supply_single_stroke' => 'Amenage matière course simple',
        'd2u_machinery_steel_beam_color_guns' => 'Nombre de pistolets de peinture',
        'd2u_machinery_steel_beam_continuous_opening' => 'Ouverture de passage',
        'd2u_machinery_steel_beam_turbine_power' => 'Puissance par turbine',
        'd2u_machinery_steel_beam_turbines' => 'Nombre de turbines',
        'd2u_machinery_steel_bevel_angle' => 'Angle de chanfreinage max.',
        'd2u_machinery_steel_carrier_height' => 'Hauteur du profil min. / max.',
        'd2u_machinery_steel_carrier_weight' => 'Poids du profil max.',
        'd2u_machinery_steel_carrier_width' => 'Largeur du profil min. / max.',
        'd2u_machinery_steel_component_length' => 'Longueur de la pièce min. / max.',
        'd2u_machinery_steel_component_weight' => 'Poids de la pièce max.',
        'd2u_machinery_steel_drilling_axis_drive_power' => 'Puissance d\'entraînement par axe',
        'd2u_machinery_steel_drilling_diameter' => 'Diamètre de perçage',
        'd2u_machinery_steel_drilling_rpm_speed' => 'Vitesse de rotation broche max.',
        'd2u_machinery_steel_drilling_tools_axis' => 'Nombre d\'outils par axe',
        'd2u_machinery_steel_drilling_unit_below' => 'Unités de forage par le bas (axe U, en option)',
        'd2u_machinery_steel_drilling_unit_horizontal' => 'Unités de perçage horizontales (axe Z et W)',
        'd2u_machinery_steel_drilling_unit_vertical' => 'Unités de perçage vertical (axe Y)',
        'd2u_machinery_steel_flange_thickness' => 'Epaisseur des ailes min. / max',
        'd2u_machinery_steel_materials' => 'Classe matière',
        'd2u_machinery_steel_procedures' => 'Procédés',
        'd2u_machinery_steel_processes' => 'Processus ',
        'd2u_machinery_steel_profiles' => 'Capacité profil',
        'd2u_machinery_steel_punching_diameter' => 'Unité de poinçonnage diamètre de poinçonnage',
        'd2u_machinery_steel_punching_power' => 'Puissance de frappe',
        'd2u_machinery_steel_punching_tools' => 'Unité de poinçonnage nombre d\'outils',
        'd2u_machinery_steel_saw_band' => 'Ruban',
        'd2u_machinery_steel_saw_band_tilt' => 'Inclinaison ruban',
        'd2u_machinery_steel_saw_blade' => 'Lame',
        'd2u_machinery_steel_saw_cutting_speed' => 'Vitesse de coupe (optionnel)',
        'd2u_machinery_steel_saw_miter' => 'Capacité coupe biaise',
        'd2u_machinery_steel_shaving_unit_angle_steel_single_cut' => 'Unité de cisaillage coupe simple à cornières',
        'd2u_machinery_steel_sheet_length' => 'Longueur de tôles',
        'd2u_machinery_steel_sheet_thickness' => 'Épaisseur de tôles',
        'd2u_machinery_steel_sheet_width' => 'Largeur de tôles',
        'd2u_machinery_steel_tool_changer_locations' => 'Changeur d\'outils x places dans magasin',
        'd2u_machinery_steel_tools' => 'Outils',
        'd2u_machinery_steel_web_thickness' => 'Épaisseur âme min. / max.',
        'd2u_machinery_steel_welding_thickness' => 'Épaisseur du cordon de soudure max.',
        'd2u_machinery_steel_welding_wire_thickness' => 'Epaisseur du fil',
        'd2u_machinery_steel_weldings' => 'Technique de soudure - une à trois passes de soudure',
        'd2u_machinery_steel_workspace_flat' => 'Capacité fers plats',
        'd2u_machinery_steel_workspace_plate' => 'Capacité tôles',
        'd2u_machinery_steel_workspace' => 'Capacité maxi.',
        'd2u_machinery_steel_workspace_angle_steel' => 'Capacité cornières',
        'd2u_machinery_steel_workspace_min' => 'Capacité mini.',
        'd2u_machinery_steel_workspace_profile' => 'Capacité profilés',
        'd2u_machinery_steel_workspace_round' => 'Capacité matière ronde',
        'd2u_machinery_steel_workspace_square' => 'Capacité matière rectangulaire',
    ];

    /**
     * @var array<string, string> Array with spanish replacements. Key is the wildcard,
     * value the replacement.
     */
    protected array $replacements_spanish = [
        'd2u_machinery_steel_automation_automationgrades' => 'Grado de automatización',
        'd2u_machinery_steel_automation_feedrate' => 'Avance',
        'd2u_machinery_steel_automation_feedrate_sawblade' => 'Avance disco de corte',
        'd2u_machinery_steel_automation_rush_leader_flyback' => 'Avance/retorno rápido',
        'd2u_machinery_steel_automation_supply_ids' => 'Lado de entrada/salida',
        'd2u_machinery_steel_automation_supply_multi_stroke' => 'Alimentación del material Carrera múltiple',
        'd2u_machinery_steel_automation_supply_single_stroke' => 'Alimentación del material Carrera simple ',
        'd2u_machinery_steel_beam_color_guns' => 'Número de pistolas de pintura',
        'd2u_machinery_steel_beam_continuous_opening' => 'Rango de paso',
        'd2u_machinery_steel_beam_turbine_power' => 'Potencia por turbina',
        'd2u_machinery_steel_beam_turbines' => 'Número de turbinas',
        'd2u_machinery_steel_bevel_angle' => 'Ángulo máx. del chaflán',
        'd2u_machinery_steel_carrier_height' => 'Altura de la viga min. / max.',
        'd2u_machinery_steel_carrier_weight' => 'Peso max. de viga',
        'd2u_machinery_steel_carrier_width' => 'Ancho de viga min. / max.',
        'd2u_machinery_steel_component_length' => 'Longitud de la pieza min. / max.',
        'd2u_machinery_steel_component_weight' => 'Peso de la pieza max.',
        'd2u_machinery_steel_drilling_axis_drive_power' => 'Potencia motriz por eje',
        'd2u_machinery_steel_drilling_diameter' => 'Diámetro de taladrado',
        'd2u_machinery_steel_drilling_rpm_speed' => 'Velocidad máxima del husillo.',
        'd2u_machinery_steel_drilling_tools_axis' => 'Número de herramientas por eje',
        'd2u_machinery_steel_drilling_unit_below' => 'Unidades de taladrado desde abajo (eje U, opcional)',
        'd2u_machinery_steel_drilling_unit_horizontal' => 'Unidades de taladrado horizontal (ejes Z y W)',
        'd2u_machinery_steel_drilling_unit_vertical' => 'Unidades de taladrado vertical (eje Y)',
        'd2u_machinery_steel_flange_thickness' => 'Espesor de ala min. / max.',
        'd2u_machinery_steel_materials' => 'Clase de material',
        'd2u_machinery_steel_procedures' => 'Método',
        'd2u_machinery_steel_processes' => 'Proceso',
        'd2u_machinery_steel_profiles' => 'Rango de perfil',
        'd2u_machinery_steel_punching_diameter' => 'Unidad de punzonado Diámetro de taladrado',
        'd2u_machinery_steel_punching_power' => 'Potencia punzonado',
        'd2u_machinery_steel_punching_tools' => 'Unidad de punzonado Núm. Herramientas',
        'd2u_machinery_steel_saw_band' => 'Cinta de corte',
        'd2u_machinery_steel_saw_band_tilt' => 'Inclinación de la cinta',
        'd2u_machinery_steel_saw_blade' => 'Disco de corte',
        'd2u_machinery_steel_saw_cutting_speed' => 'Velocidad de corte',
        'd2u_machinery_steel_saw_miter' => 'Rango de inglete',
        'd2u_machinery_steel_shaving_unit_angle_steel_single_cut' => 'Cizalla para angulares de acero Corte simple',
        'd2u_machinery_steel_sheet_length' => 'Chapa - Material de partida, longitud chapa',
        'd2u_machinery_steel_sheet_thickness' => 'Chapa - Material de partida, espesor chapa',
        'd2u_machinery_steel_sheet_width' => 'Chapa - Material de partida, anchura chapa',
        'd2u_machinery_steel_tool_changer_locations' => 'Cambiador de herramientas x puestos de cargdor',
        'd2u_machinery_steel_tools' => 'Herramientas',
        'd2u_machinery_steel_web_thickness' => 'Espesor de alma min. / max.',
        'd2u_machinery_steel_welding_thickness' => 'Garganta soldadura espesor max.',
        'd2u_machinery_steel_welding_wire_thickness' => 'Grosor del hilo',
        'd2u_machinery_steel_weldings' => 'Soldadura en una pasada - tres pasadas de soldadura',
        'd2u_machinery_steel_workspace' => 'Área de trabajo máx.',
        'd2u_machinery_steel_workspace_angle_steel' => 'Área de trabajo Angulares de acero',
        'd2u_machinery_steel_workspace_flat' => 'Área de trabajo Llantas',
        'd2u_machinery_steel_workspace_min' => 'Área de trabajo mín.',
        'd2u_machinery_steel_workspace_plate' => 'Área de trabajo Placas',
        'd2u_machinery_steel_workspace_profile' => 'Área de trabajo Perfiles',
        'd2u_machinery_steel_workspace_round' => 'Área de trabajo Material redondo',
        'd2u_machinery_steel_workspace_square' => 'Área de trabajo Material cuadrado',
    ];

    /**
     * @var array<string, string> Array with dutch replacements. Key is the wildcard,
     * value the replacement.
     */
    protected array $replacements_dutch = [
        'd2u_machinery_steel_automation_automationgrades' => 'Automatiseringsgraad',
        'd2u_machinery_steel_automation_feedrate' => 'Voeding',
        'd2u_machinery_steel_automation_feedrate_sawblade' => 'Zaagblad doorvoersnelheid',
        'd2u_machinery_steel_automation_rush_leader_flyback' => 'Snelle voor-/terugloop',
        'd2u_machinery_steel_automation_supply_ids' => 'Aan- en afvoerkant',
        'd2u_machinery_steel_automation_supply_multi_stroke' => 'Materiaalvoeding meervoudige slag',
        'd2u_machinery_steel_automation_supply_single_stroke' => 'Materiaalvoeding enkelvoudige slag ',
        'd2u_machinery_steel_beam_color_guns' => 'Aantal verfpistolen',
        'd2u_machinery_steel_beam_continuous_opening' => 'Doorvoeropening',
        'd2u_machinery_steel_beam_turbine_power' => 'Vermogen per turbine',
        'd2u_machinery_steel_beam_turbines' => 'Aantal turbines',
        'd2u_machinery_steel_bevel_angle' => 'Fasenhoek max.',
        'd2u_machinery_steel_carrier_height' => 'Breedte hoogte min. / max.',
        'd2u_machinery_steel_carrier_weight' => 'Breedte gewicht max.',
        'd2u_machinery_steel_carrier_width' => 'Bundelbreedte min. / max.',
        'd2u_machinery_steel_component_length' => 'Deel lengte min. / max.',
        'd2u_machinery_steel_component_weight' => 'Deel gewicht max.',
        'd2u_machinery_steel_drilling_axis_drive_power' => 'Aandrijfvermogen per as',
        'd2u_machinery_steel_drilling_diameter' => 'Boordiameter',
        'd2u_machinery_steel_drilling_rpm_speed' => 'Toerental spindel max.',
        'd2u_machinery_steel_drilling_tools_axis' => 'Aantal gereedschappen per as',
        'd2u_machinery_steel_drilling_unit_below' => 'Boorelementen van onderen (U-as, facultatief)',
        'd2u_machinery_steel_drilling_unit_horizontal' => 'Boorelementen horizontaal (Z- en W-as)',
        'd2u_machinery_steel_drilling_unit_vertical' => 'Boorelementen verticaal (Y-as)',
        'd2u_machinery_steel_flange_thickness' => 'Flensdikte min. / max',
        'd2u_machinery_steel_materials' => 'Materiaalklasse ',
        'd2u_machinery_steel_procedures' => 'Procédé',
        'd2u_machinery_steel_processes' => 'Proces',
        'd2u_machinery_steel_profiles' => 'Profiel gebied',
        'd2u_machinery_steel_punching_diameter' => 'Ponselement ponsdiameter',
        'd2u_machinery_steel_punching_power' => 'Slagkracht',
        'd2u_machinery_steel_punching_tools' => 'Ponselement aantal gereedschappen',
        'd2u_machinery_steel_saw_band' => 'Zaagband',
        'd2u_machinery_steel_saw_band_tilt' => 'Zaagbandhoek',
        'd2u_machinery_steel_saw_blade' => 'Zaagblad',
        'd2u_machinery_steel_saw_cutting_speed' => 'Zaagsnelheid',
        'd2u_machinery_steel_saw_miter' => 'Verstekbereik',
        'd2u_machinery_steel_shaving_unit_angle_steel_single_cut' => 'Hoekstaal-ponselement single cut',
        'd2u_machinery_steel_sheet_length' => 'Uitgangsmateriaal plaatstaal plaatlengte',
        'd2u_machinery_steel_sheet_thickness' => 'Uitgangsmateriaal plaatstaal plaatdikte',
        'd2u_machinery_steel_sheet_width' => 'Uitgangsmateriaal plaatstaal plaatbreedte',
        'd2u_machinery_steel_tool_changer_locations' => 'Vervanger gereedschap x magazijnplaatsen',
        'd2u_machinery_steel_tools' => 'Gereedschappen',
        'd2u_machinery_steel_web_thickness' => 'Lijfdikte min. / max.',
        'd2u_machinery_steel_welding_thickness' => 'Lassen keelhoogte max.',
        'd2u_machinery_steel_welding_wire_thickness' => 'Draaddikte',
        'd2u_machinery_steel_weldings' => 'Lastechniek - one-pass - drie-pass lassen',
        'd2u_machinery_steel_workspace_flat' => 'Werkbereik vlak materiaal',
        'd2u_machinery_steel_workspace_plate' => 'Werkbereik platen',
        'd2u_machinery_steel_workspace' => 'Werkbereik max.',
        'd2u_machinery_steel_workspace_angle_steel' => 'Werkbereik hoekstaal',
        'd2u_machinery_steel_workspace_min' => 'Werkbereik min.',
        'd2u_machinery_steel_workspace_profile' => 'Werkbereik profielen',
        'd2u_machinery_steel_workspace_round' => 'Werkbereik rond materiaal',
        'd2u_machinery_steel_workspace_square' => 'Werkbereik vierkant materiaal',
    ];

    /**
     * @var array<string, string> Array with russian replacements. Key is the wildcard,
     * value the replacement.
     */
    protected array $replacements_russian = [
        'd2u_machinery_steel_automation_automationgrades' => 'Степень автоматизации',
        'd2u_machinery_steel_automation_feedrate' => 'Сторона загрузки',
        'd2u_machinery_steel_automation_feedrate_sawblade' => 'Скорость подачи пилы',
        'd2u_machinery_steel_automation_rush_leader_flyback' => 'Ускоренный ход вперед и назад',
        'd2u_machinery_steel_automation_supply_ids' => 'Сторона загрузки/ разгрузки',
        'd2u_machinery_steel_automation_supply_multi_stroke' => 'Подача заготовки - многократное продвижение материала',
        'd2u_machinery_steel_automation_supply_single_stroke' => 'Подача заготовки - однократное продвижение материала',
        'd2u_machinery_steel_beam_color_guns' => 'Количество распылительных форсунок',
        'd2u_machinery_steel_beam_continuous_opening' => 'Габариты входного окна',
        'd2u_machinery_steel_beam_turbine_power' => 'Мощность одной турбины',
        'd2u_machinery_steel_beam_turbines' => 'Количество турбин',
        'd2u_machinery_steel_bevel_angle' => 'Угол снятия фаски макс.',
        'd2u_machinery_steel_carrier_height' => 'Регулировка по высоте мин./макс.',
        'd2u_machinery_steel_carrier_weight' => 'Транспортируемый вес макс.',
        'd2u_machinery_steel_carrier_width' => 'Диапазон ширины материала мин. / макс.',
        'd2u_machinery_steel_component_length' => 'Длина материала мин./ макс.',
        'd2u_machinery_steel_component_weight' => 'Вес материала мин./макс.',
        'd2u_machinery_steel_drilling_axis_drive_power' => 'Мощность привода на ось',
        'd2u_machinery_steel_drilling_diameter' => 'Диаметр сверления',
        'd2u_machinery_steel_drilling_rpm_speed' => 'Скорость вращения шпинделя макс.',
        'd2u_machinery_steel_drilling_tools_axis' => 'Количество инструментов на ось',
        'd2u_machinery_steel_drilling_unit_below' => 'Буровые установки снизу (ось U, опциональный)',
        'd2u_machinery_steel_drilling_unit_horizontal' => 'Горизонтальные блоки сверления (оси Z и W)',
        'd2u_machinery_steel_drilling_unit_vertical' => 'Вертикальный блок сверления (ось Y)',
        'd2u_machinery_steel_flange_thickness' => 'Толщина фланца мин./ макс.',
        'd2u_machinery_steel_materials' => 'Сорт металла',
        'd2u_machinery_steel_procedures' => 'Технология',
        'd2u_machinery_steel_processes' => 'Процесс',
        'd2u_machinery_steel_profiles' => 'Тип профиля',
        'd2u_machinery_steel_punching_diameter' => 'Блок штамповки - диаметр пуансона макс.',
        'd2u_machinery_steel_punching_power' => 'Усилие штамповки',
        'd2u_machinery_steel_punching_tools' => 'Блок штамповки - количество пуансонов на ось',
        'd2u_machinery_steel_saw_band' => 'Полотно пилы',
        'd2u_machinery_steel_saw_band_tilt' => 'Наклон полотна пилы',
        'd2u_machinery_steel_saw_blade' => 'Полотно пилы',
        'd2u_machinery_steel_saw_cutting_speed' => 'Скорость распила (по желанию)',
        'd2u_machinery_steel_saw_miter' => 'Диапазон изменения угла распила',
        'd2u_machinery_steel_shaving_unit_angle_steel_single_cut' => 'Блок гильотины - одноходовый рез',
        'd2u_machinery_steel_sheet_length' => 'Исходный листовой металл - длина',
        'd2u_machinery_steel_sheet_thickness' => 'Исходный листовой металл - толщина',
        'd2u_machinery_steel_sheet_width' => 'Исходный листовой металл - ширина',
        'd2u_machinery_steel_tools' => 'Инструмент',
        'd2u_machinery_steel_tool_changer_locations' => 'Устройство для смены инструмента х количество инструментов',
        'd2u_machinery_steel_web_thickness' => 'Угол снятия фаски мин./ макс.',
        'd2u_machinery_steel_weldings' => 'Сварочный робот - Одна манипуляция - три сварных шва',
        'd2u_machinery_steel_welding_thickness' => 'Сварочные горло толщиной макс.',
        'd2u_machinery_steel_welding_wire_thickness' => 'Толщина проволоки',
        'd2u_machinery_steel_workspace' => 'Рабочий диапазон макс.',
        'd2u_machinery_steel_workspace_angle_steel' => 'Обрабатываемый материал - угловой профиль',
        'd2u_machinery_steel_workspace_flat' => 'Обрабатываемый материал - полосовая сталь',
        'd2u_machinery_steel_workspace_min' => 'Рабочий диапазон мин.',
        'd2u_machinery_steel_workspace_plate' => 'Рабочий диапазон - листовой металл',
        'd2u_machinery_steel_workspace_profile' => 'Рабочий диапазон - профильный прокат',
        'd2u_machinery_steel_workspace_round' => 'Обрабатываемый материал - профиль круглого сечения',
        'd2u_machinery_steel_workspace_square' => 'Обрабатываемый материал - профиль квадратного сечения',
    ];

    /**
     * @var array<string, string> Array with portuguese replacements. Key is the wildcard,
     * value the replacement.
     */
    protected array $replacements_portuguese = [
        'd2u_machinery_steel_automation_automationgrades' => 'Nível de automação',
        'd2u_machinery_steel_automation_feedrate' => 'Avanço',
        'd2u_machinery_steel_automation_feedrate_sawblade' => 'Taxa de alimentação da lâmina de serra',
        'd2u_machinery_steel_automation_rush_leader_flyback' => 'Avanço rápido/recuo',
        'd2u_machinery_steel_automation_supply_ids' => 'Lado da alimentação/saída',
        'd2u_machinery_steel_automation_supply_multi_stroke' => 'Deslocação do material após processamento com levantamento múltiplo',
        'd2u_machinery_steel_automation_supply_single_stroke' => 'Deslocação do material após processamento com levantamento simples',
        'd2u_machinery_steel_beam_color_guns' => 'Número de pistolas de pintura',
        'd2u_machinery_steel_beam_continuous_opening' => 'Abertura de passagem',
        'd2u_machinery_steel_beam_turbine_power' => 'Potência por turbina',
        'd2u_machinery_steel_beam_turbines' => 'Número de turbinas',
        'd2u_machinery_steel_bevel_angle' => 'Ângulo do chanfro máx.',
        'd2u_machinery_steel_carrier_height' => 'Altura da viga min. / max.',
        'd2u_machinery_steel_carrier_weight' => 'Peso da viga max.',
        'd2u_machinery_steel_carrier_width' => 'Largura da viga min. / max.',
        'd2u_machinery_steel_component_length' => 'Comprimento da parte min. / max.',
        'd2u_machinery_steel_component_weight' => 'Peso da parte max.',
        'd2u_machinery_steel_drilling_axis_drive_power' => 'Potência propulsora por eixo',
        'd2u_machinery_steel_drilling_diameter' => 'Diâmetro do furo',
        'd2u_machinery_steel_drilling_rpm_speed' => 'Rotações máx. do fuso',
        'd2u_machinery_steel_drilling_tools_axis' => 'Número de ferramentas por eixo',
        'd2u_machinery_steel_drilling_unit_below' => 'Unidades de furação por baixo (eixo U, opcional)',
        'd2u_machinery_steel_drilling_unit_horizontal' => 'Unidades de furação horizontal (eixo Z e W)',
        'd2u_machinery_steel_drilling_unit_vertical' => 'Unidades de furação vertical (eixo Y)',
        'd2u_machinery_steel_flange_thickness' => 'Espessura da flange min. / max',
        'd2u_machinery_steel_materials' => 'Classe de material',
        'd2u_machinery_steel_procedures' => 'Procedimento',
        'd2u_machinery_steel_processes' => 'Processo',
        'd2u_machinery_steel_profiles' => 'Área de perfil',
        'd2u_machinery_steel_punching_diameter' => 'Unidade de estampagem diâmetro da estampagem',
        'd2u_machinery_steel_punching_power' => 'Poder de perfuração',
        'd2u_machinery_steel_punching_tools' => 'Unidade de estampagem Número de ferramentas',
        'd2u_machinery_steel_saw_band' => 'Fita da serra',
        'd2u_machinery_steel_saw_band_tilt' => 'Inclinação da fita da serra',
        'd2u_machinery_steel_saw_blade' => 'Folha da serra',
        'd2u_machinery_steel_saw_cutting_speed' => 'Velocidade de corte',
        'd2u_machinery_steel_saw_miter' => 'Área da esquadria',
        'd2u_machinery_steel_shaving_unit_angle_steel_single_cut' => 'Cisalha para cantoneiras de corte simples',
        'd2u_machinery_steel_sheet_length' => 'Chapas - material de saída comprimento da chapa',
        'd2u_machinery_steel_sheet_thickness' => 'Chapas - material de saída - espessura da chapa',
        'd2u_machinery_steel_sheet_width' => 'Chapas - material de saída largura da chapa',
        'd2u_machinery_steel_tool_changer_locations' => 'Dispositivo de mudança de ferramenta x lugares no carregador',
        'd2u_machinery_steel_tools' => 'Ferramentas',
        'd2u_machinery_steel_web_thickness' => 'Espessura Web min. / max.',
        'd2u_machinery_steel_welding_thickness' => 'Espessura da garganta de solda max.',
        'd2u_machinery_steel_welding_wire_thickness' => 'Espessura do fio',
        'd2u_machinery_steel_weldings' => 'Técnica de soldagem - uma passagem - três-pass de soldagem',
        'd2u_machinery_steel_workspace_flat' => 'Área de trabalho para material plano',
        'd2u_machinery_steel_workspace_plate' => 'Área de trabalho para placas',
        'd2u_machinery_steel_workspace' => 'Área de trabalho máx.',
        'd2u_machinery_steel_workspace_angle_steel' => 'Área de trabalho para cantoneiras',
        'd2u_machinery_steel_workspace_min' => 'Área de trabalho',
        'd2u_machinery_steel_workspace_profile' => 'Área de trabalho para perfis',
        'd2u_machinery_steel_workspace_round' => 'Área de trabalho para varões',
        'd2u_machinery_steel_workspace_square' => 'Área de trabalho para barras rectangulares',
    ];

    /**
     * @var array<string, string> Array with chinese replacements. Key is the wildcard,
     * value the replacement.
     */
    protected array $replacements_chinese = [
        'd2u_machinery_steel_automation_automationgrades' => '自动化程度',
        'd2u_machinery_steel_automation_feedrate' => '喂料',
        'd2u_machinery_steel_automation_feedrate_sawblade' => '锯片进给速度',
        'd2u_machinery_steel_automation_rush_leader_flyback' => '快速前进流/回流',
        'd2u_machinery_steel_automation_supply_ids' => '进料/出料端',
        'd2u_machinery_steel_automation_supply_multi_stroke' => '进料多冲程',
        'd2u_machinery_steel_automation_supply_single_stroke' => '进料单冲程',
        'd2u_machinery_steel_beam_color_guns' => '喷枪数量',
        'd2u_machinery_steel_beam_continuous_opening' => '接口',
        'd2u_machinery_steel_beam_turbine_power' => '涡轮机功率',
        'd2u_machinery_steel_beam_turbines' => '梁高最小/最大',
        'd2u_machinery_steel_bevel_angle' => '斜角最大',
        'd2u_machinery_steel_carrier_height' => '梁高最小/最大',
        'd2u_machinery_steel_carrier_weight' => '梁重最大',
        'd2u_machinery_steel_carrier_width' => '梁宽最小/最大',
        'd2u_machinery_steel_component_length' => '部件长度最短/最长',
        'd2u_machinery_steel_component_weight' => '部件重量最大',
        'd2u_machinery_steel_drilling_axis_drive_power' => '每根轴的驱动功率',
        'd2u_machinery_steel_drilling_diameter' => '钻孔直径',
        'd2u_machinery_steel_drilling_rpm_speed' => '主轴转速最大',
        'd2u_machinery_steel_drilling_tools_axis' => '每根轴的刀具数量',
        'd2u_machinery_steel_drilling_unit_below' => '下方钻探单元（U 轴, 可选）',
        'd2u_machinery_steel_drilling_unit_horizontal' => '水平钻孔单元（Z 轴与 W 轴）',
        'd2u_machinery_steel_drilling_unit_vertical' => '垂直钻孔单元（Y 轴）',
        'd2u_machinery_steel_flange_thickness' => '轮缘厚度最大/最小',
        'd2u_machinery_steel_materials' => '材料等级',
        'd2u_machinery_steel_procedures' => '流程',
        'd2u_machinery_steel_processes' => '工艺',
        'd2u_machinery_steel_profiles' => '型材范围',
        'd2u_machinery_steel_punching_diameter' => '冲剪机冲孔直径',
        'd2u_machinery_steel_punching_power' => '冲力',
        'd2u_machinery_steel_punching_tools' => '冲孔刀具数量',
        'd2u_machinery_steel_saw_band' => '锯带',
        'd2u_machinery_steel_saw_band_tilt' => '锯带偏转角度',
        'd2u_machinery_steel_saw_blade' => '锯片',
        'd2u_machinery_steel_saw_cutting_speed' => '切割速度 (可选的)',
        'd2u_machinery_steel_saw_miter' => '斜角范围',
        'd2u_machinery_steel_shaving_unit_angle_steel_single_cut' => '角钢冲剪机单切刀',
        'd2u_machinery_steel_sheet_length' => '板材原料长度',
        'd2u_machinery_steel_sheet_thickness' => '板材原料厚度',
        'd2u_machinery_steel_sheet_width' => '板材原料宽度',
        'd2u_machinery_steel_tool_changer_locations' => '换刀装置 x 刀具位置',
        'd2u_machinery_steel_tools' => '刀具',
        'd2u_machinery_steel_web_thickness' => '板材厚度最小/最大',
        'd2u_machinery_steel_welding_thickness' => '焊接厚度最大',
        'd2u_machinery_steel_welding_wire_thickness' => '线厚',
        'd2u_machinery_steel_weldings' => '焊接工艺：一至三层焊接',
        'd2u_machinery_steel_workspace_flat' => '平料工作区域',
        'd2u_machinery_steel_workspace_plate' => '板材工作区域',
        'd2u_machinery_steel_workspace' => '工作区域最大',
        'd2u_machinery_steel_workspace_angle_steel' => '角钢工作区域',
        'd2u_machinery_steel_workspace_min' => '工作区域最小',
        'd2u_machinery_steel_workspace_profile' => '型材工作区域',
        'd2u_machinery_steel_workspace_round' => '圆材工作区域',
        'd2u_machinery_steel_workspace_square' => '矩形材料工作区域',
    ];

    /**
     * Factory method.
     * @return d2u_machinery_machine_steel_processing_extension_lang_helper Object
     */
    public static function factory()
    {
        return new self();
    }
}
